object FormMain: TFormMain
  Left = 192
  Top = 107
  Caption = 'Multibase Transaction'
  ClientHeight = 339
  ClientWidth = 462
  Color = clBtnFace
  Font.Charset = DEFAULT_CHARSET
  Font.Color = clWindowText
  Font.Height = -11
  Font.Name = 'MS Sans Serif'
  Font.Style = []
  Menu = MainMenu1
  OldCreateOrder = False
  WindowState = wsMaximized
  OnClose = FormClose
  OnShow = FormShow
  PixelsPerInch = 96
  TextHeight = 13
  object Splitter1: TSplitter
    Left = 0
    Top = 173
    Width = 462
    Height = 5
    Cursor = crVSplit
    Align = alTop
  end
  object DBGridCtr: TDBGrid
    Left = 0
    Top = 0
    Width = 462
    Height = 173
    Align = alTop
    DataSource = DSCountry
    Options = [dgEditing, dgTitles, dgColumnResize, dgColLines, dgRowLines, dgTabs, dgAlwaysShowSelection, dgConfirmDelete, dgCancelOnExit]
    TabOrder = 0
    TitleFont.Charset = DEFAULT_CHARSET
    TitleFont.Color = clWindowText
    TitleFont.Height = -11
    TitleFont.Name = 'MS Sans Serif'
    TitleFont.Style = []
    Columns = <
      item
        Expanded = False
        FieldName = 'CODCTR'
        Width = 55
        Visible = True
      end
      item
        Expanded = False
        FieldName = 'NAME'
        Width = 140
        Visible = True
      end
      item
        Expanded = False
        FieldName = 'FULLNAME'
        Width = 230
        Visible = True
      end>
  end
  object DBGridPers: TDBGrid
    Left = 0
    Top = 178
    Width = 462
    Height = 161
    Align = alClient
    DataSource = DSPerson
    Options = [dgEditing, dgTitles, dgIndicator, dgColumnResize, dgColLines, dgRowLines, dgTabs, dgAlwaysShowSelection, dgConfirmDelete, dgCancelOnExit]
    TabOrder = 1
    TitleFont.Charset = DEFAULT_CHARSET
    TitleFont.Color = clWindowText
    TitleFont.Height = -11
    TitleFont.Name = 'MS Sans Serif'
    TitleFont.Style = []
    Columns = <
      item
        Expanded = False
        FieldName = 'CODPERS'
        Width = 59
        Visible = True
      end
      item
        Expanded = False
        FieldName = 'FIRST_NAME'
        Width = 106
        Visible = True
      end
      item
        Expanded = False
        FieldName = 'LAST_NAME'
        Width = 185
        Visible = True
      end
      item
        Expanded = False
        FieldName = 'COUNTRY'
        Visible = True
      end>
  end
  object CountryDatabase: TpFIBDatabase
    DBName = 'COUNTRY.GDB'
    DBParams.Strings = (
      'lc_ctype=WIN1251'
      'user_name=SYSDBA'
      'password=masterkey')
    DefaultTransaction = ReadTransaction
    DefaultUpdateTransaction = WriteTransaction
    SQLDialect = 3
    Timeout = 0
    DesignDBOptions = []
    LibraryName = 'fbclient.dll'
    WaitForRestoreConnect = 0
    Left = 20
    Top = 65
  end
  object WriteTransaction: TpFIBTransaction
    DefaultDatabase = CountryDatabase
    TimeoutAction = TARollback
    BeforeStart = WriteTransactionBeforeStart
    AfterEnd = WriteTransactionAfterEnd
    Left = 113
    Top = 121
  end
  object CountryData: TpFIBDataSet
    UpdateSQL.Strings = (
      'UPDATE REFCOUNTRY'
      'SET '
      '    NAME = :NAME,'
      '    FULLNAME = :FULLNAME,'
      '    CODCTR = :CODCTR'
      'WHERE'
      '    CODCTR = :OLD_CODCTR'
      '    ')
    DeleteSQL.Strings = (
      'DELETE FROM'
      '    REFCOUNTRY'
      'WHERE'
      '        CODCTR = :OLD_CODCTR'
      '    ')
    InsertSQL.Strings = (
      'INSERT INTO REFCOUNTRY('
      '    NAME,'
      '    FULLNAME,'
      '    CODCTR'
      ')'
      'VALUES('
      '    :NAME,'
      '    :FULLNAME,'
      '    :CODCTR'
      ')')
    RefreshSQL.Strings = (
      'SELECT'
      '    NAME,'
      '    FULLNAME,'
      '    CODCTR'
      'FROM'
      '    REFCOUNTRY '
      '    '
      ' WHERE '
      '        REFCOUNTRY.CODCTR = :OLD_CODCTR'
      '    '
      'ORDER BY NAME')
    SelectSQL.Strings = (
      'SELECT'
      '    NAME,'
      '    FULLNAME,'
      '    CODCTR'
      'FROM'
      '    REFCOUNTRY '
      '    ORDER BY NAME')
    Transaction = ReadTransaction
    Database = CountryDatabase
    UpdateTransaction = WriteTransaction
    SQLScreenCursor = crSQLWait
    DefaultFormats.DateTimeDisplayFormat = 'dd.mm.yyyy'
    Left = 289
    Top = 45
    poSQLINT64ToBCD = True
    poAskRecordCount = True
    oStartTransaction = False
  end
  object DSCountry: TDataSource
    DataSet = CountryData
    Left = 362
    Top = 45
  end
  object PersonDatabase: TpFIBDatabase
    DBName = 'PERSON.GDB'
    DBParams.Strings = (
      'password=masterkey'
      'user_name=SYSDBA'
      'lc_ctype=WIN1251')
    DefaultTransaction = ReadTransaction
    DefaultUpdateTransaction = WriteTransaction
    SQLDialect = 3
    Timeout = 0
    DesignDBOptions = []
    LibraryName = 'fbclient.dll'
    WaitForRestoreConnect = 0
    Left = 144
    Top = 201
  end
  object PersonData: TpFIBDataSet
    UpdateSQL.Strings = (
      'UPDATE PERSON SET '
      '    FIRST_NAME = :FIRST_NAME,'
      '    LAST_NAME = :LAST_NAME,'
      '    COUNTRY = :COUNTRY'
      ' WHERE     '
      '            CODPERS = :OLD_CODPERS'
      '    ')
    DeleteSQL.Strings = (
      'DELETE FROM PERSON'
      'WHERE     '
      '            CODPERS = :OLD_CODPERS'
      '    ')
    InsertSQL.Strings = (
      'INSERT INTO PERSON('
      '    CODPERS,'
      '    FIRST_NAME,'
      '    LAST_NAME,'
      '    COUNTRY'
      ')'
      'VALUES('
      '    :CODPERS,'
      '    :FIRST_NAME,'
      '    :LAST_NAME,'
      '    :COUNTRY'
      ')')
    RefreshSQL.Strings = (
      'SELECT'
      '    CODPERS,'
      '    FIRST_NAME,'
      '    LAST_NAME,'
      '    COUNTRY'
      'FROM'
      '    PERSON '
      ' WHERE '
      '    (    '
      '            PERSON.CODPERS = :OLD_CODPERS'
      '    )')
    SelectSQL.Strings = (
      'SELECT'
      '    CODPERS,'
      '    FIRST_NAME,'
      '    LAST_NAME,'
      '    COUNTRY'
      'FROM'
      '    PERSON ')
    AutoUpdateOptions.UpdateTableName = 'PERSON'
    AutoUpdateOptions.KeyFields = 'CODPERS'
    AutoUpdateOptions.GeneratorName = 'GEN_PERSON'
    AutoUpdateOptions.WhenGetGenID = wgBeforePost
    BeforePost = PersonDataBeforePost
    Transaction = ReadTransaction
    Database = PersonDatabase
    UpdateTransaction = WriteTransaction
    AutoCommit = True
    Left = 243
    Top = 200
    poSQLINT64ToBCD = True
    poAskRecordCount = True
  end
  object DSPerson: TDataSource
    DataSet = PersonData
    Left = 420
    Top = 184
  end
  object CountryEdited: TpFIBUpdateObject
    Transaction = WriteTransaction
    Database = PersonDatabase
    SQL.Strings = (
      'UPDATE PERSON SET COUNTRY = :CODCTR'
      'WHERE COUNTRY = :OLD_CODCTR')
    DataSet = CountryData
    OrderInList = 0
    ExecuteOrder = oeAfterDefault
    Left = 365
    Top = 113
  end
  object ReadTransaction: TpFIBTransaction
    DefaultDatabase = CountryDatabase
    TimeoutAction = TARollback
    Left = 19
    Top = 121
  end
  object CountryDeleted: TpFIBUpdateObject
    Transaction = WriteTransaction
    Database = PersonDatabase
    SQL.Strings = (
      'DELETE FROM PERSON'
      'WHERE COUNTRY = :OLD_CODCTR')
    DataSet = CountryData
    OrderInList = 0
    KindUpdate = ukDelete
    ExecuteOrder = oeAfterDefault
    Left = 290
    Top = 112
  end
  object PersonAdded: TpFIBUpdateObject
    Transaction = ReadTransaction
    Database = CountryDatabase
    SQL.Strings = (
      'EXECUTE PROCEDURE TEST_COUNTRY (:CODCTR)')
    DataSet = PersonData
    OrderInList = 0
    KindUpdate = ukInsert
    Left = 242
    Top = 261
  end
  object PersonChanged: TpFIBUpdateObject
    Transaction = ReadTransaction
    Database = CountryDatabase
    SQL.Strings = (
      'EXECUTE PROCEDURE TEST_COUNTRY (:CODCTR)')
    DataSet = PersonData
    OrderInList = 0
    Left = 314
    Top = 261
  end
  object MainMenu1: TMainMenu
    Left = 128
    Top = 8
    object MTransaction: TMenuItem
      Caption = 'Transaction'
      object MCommit: TMenuItem
        Caption = 'Commit'
        OnClick = MCommitClick
      end
      object MRollback: TMenuItem
        Caption = 'Rollback'
        OnClick = MRollbackClick
      end
      object MTransactDatabases: TMenuItem
        Caption = 'Transact Databases'
        OnClick = MTransactDatabasesClick
      end
    end
  end
end
